--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity SEG7DISP is
	port (
		SFTDT_U		: in  std_logic_vector(2 downto 0);
		SFTDT_D		: in  std_logic_vector(2 downto 0);
		SFTHS_U		: in  std_logic_vector(2 downto 0);
		SFTHS_D		: in  std_logic_vector(2 downto 0);
		HEX3_D		: out std_logic_vector(6 downto 0);
		HEX3_DP		: out std_logic;
		HEX2_D		: out std_logic_vector(6 downto 0);
		HEX2_DP		: out std_logic;
		HEX1_D		: out std_logic_vector(6 downto 0);
		HEX1_DP		: out std_logic;
		HEX0_D		: out std_logic_vector(6 downto 0);
		HEX0_DP		: out std_logic
	);
end SEG7DISP;

architecture RTL of SEG7DISP is

	component SEG7SUB is
		port (
			DATA		: in  std_logic_vector(7 downto 0);
			HEX_D		: out std_logic_vector(6 downto 0);
			HEX_DP		: out std_logic
		);
	end component;

	signal seldisp3	: std_logic_vector(7 downto 0);
	signal seldisp2	: std_logic_vector(7 downto 0);
	signal seldisp1	: std_logic_vector(7 downto 0);
	signal seldisp0	: std_logic_vector(7 downto 0);


begin

	seldisp3 <=	("00000" & SFTDT_U) + X"30";
	seldisp2 <=	("00000" & SFTDT_D) + X"30";
	seldisp1 <=	("00000" & SFTHS_U) + X"30";
	seldisp0 <=	("00000" & SFTHS_D) + X"30";


	U_SEG7SUB_3 : SEG7SUB
	port map (
		DATA		=> seldisp3,
		HEX_D		=> HEX3_D,
		HEX_DP		=> HEX3_DP
	);

	U_SEG7SUB_2 : SEG7SUB
	port map (
		DATA		=> seldisp2,
		HEX_D		=> HEX2_D,
		HEX_DP		=> HEX2_DP
	);

	U_SEG7SUB_1 : SEG7SUB
	port map (
		DATA		=> seldisp1,
		HEX_D		=> HEX1_D,
		HEX_DP		=> HEX1_DP
	);

	U_SEG7SUB_0 : SEG7SUB
	port map (
		DATA		=> seldisp0,
		HEX_D		=> HEX0_D,
		HEX_DP		=> HEX0_DP
	);


end RTL;
